<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>AMC13: /work/dan/AMC13/amc13-fw/src/common/IPBUS/ipbus_core/hdl/ipbus_ctrl.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">AMC13
   </div>
   <div id="projectbrief">Firmwares for the different applications of the AMC13 uTCA board made at Boston University</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li><li class="navelem"><a class="el" href="dir_50b085d9a531d2f4fb508e8939da4f56.html">IPBUS</a></li><li class="navelem"><a class="el" href="dir_5ece166cf79c4b289e4250a1a1b0f77c.html">ipbus_core</a></li><li class="navelem"><a class="el" href="dir_6b8acfab6d0e4d624803b58e4502256d.html">hdl</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ipbus_ctrl.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="keyword">-- ipbus_ctrl</span><span class="keyword"></span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">-- Top level <span class="vhdlkeyword">of</span> the ipbus <span class="vhdlkeyword">bus</span> master</span><span class="keyword"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">--</span><span class="keyword"></span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">-- Bridges ethernet MAC interface <span class="vhdlkeyword">and</span> / <span class="vhdlkeyword">or</span> out-of-band interfaces</span><span class="keyword"></span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">to</span> the ipbus.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">-- Dave Newbold, Sep </span><span class="vhdllogic">2012</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">ieee</span>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_1164.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classipbus.html">ipbus</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classipbus__trans__decl.html">ipbus_trans_decl</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno"><a class="code" href="classipbus__ctrl.html">   15</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classipbus__ctrl.html">ipbus_ctrl</a> <span class="vhdlkeyword">is</span> </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="vhdlkeyword">generic</span><span class="vhdlchar">(</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="vhdlchar">MAC_CFG</span><span class="vhdlchar">:</span> <span class="vhdlchar">ipb_mac_cfg</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">EXTERNAL</span>;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="vhdlchar">IP_CFG</span><span class="vhdlchar">:</span> <span class="vhdlchar">ipb_ip_cfg</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">EXTERNAL</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">-- Number <span class="vhdlkeyword">of</span> address bits <span class="vhdlkeyword">to</span> <span class="vhdlkeyword">select</span> RX <span class="vhdlkeyword">or</span> TX <span class="vhdlkeyword">buffer</span> <span class="vhdlkeyword">in</span> UDP I/F</span><span class="keyword"></span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">-- Number <span class="vhdlkeyword">of</span> RX <span class="vhdlkeyword">and</span> TX buffers <span class="vhdlkeyword">is</span> 2**BUFWIDTH</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <span class="vhdlchar">BUFWIDTH</span><span class="vhdlchar">:</span> <span class="comment">natural</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">4</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">-- Numer <span class="vhdlkeyword">of</span> address bits <span class="vhdlkeyword">to</span> <span class="vhdlkeyword">select</span> internal <span class="vhdlkeyword">buffer</span> <span class="vhdlkeyword">in</span> UDP I/F</span><span class="keyword"></span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">-- Number <span class="vhdlkeyword">of</span> internal buffers <span class="vhdlkeyword">is</span> 2**INTERNALWIDTH</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <span class="vhdlchar">INTERNALWIDTH</span><span class="vhdlchar">:</span> <span class="comment">natural</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">-- Number <span class="vhdlkeyword">of</span> address bits within each <span class="vhdlkeyword">buffer</span> <span class="vhdlkeyword">in</span> UDP I/F</span><span class="keyword"></span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">-- Size <span class="vhdlkeyword">of</span> each <span class="vhdlkeyword">buffer</span> <span class="vhdlkeyword">is</span> 2**ADDRWIDTH</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="vhdlchar">ADDRWIDTH</span><span class="vhdlchar">:</span> <span class="comment">natural</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">11</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">-- UDP <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">for</span> IPbus traffic <span class="vhdlkeyword">in</span> this instance <span class="vhdlkeyword">of</span> UDP I/F</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="vhdlchar">IPBUSPORT</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">DOWNTO</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">x</span><span class="keyword">&quot;C351&quot;</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">-- Flag whether this UDP I/F instance ignores everything except IPBus traffic</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="vhdlchar">SECONDARYPORT</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="vhdlchar">N_OOB</span><span class="vhdlchar">:</span> <span class="comment">natural</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="vhdlkeyword">port</span><span class="vhdlchar">(</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="vhdlchar">mac_clk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- Ethernet MAC clock (125MHz)</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="vhdlchar">rst_macclk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- MAC clock domain sync reset</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="vhdlchar">ipb_clk</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- IPbus clock</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="vhdlchar">rst_ipb</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;<span class="keyword"> -- IPbus clock domain sync reset</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="vhdlchar">mac_rx_data</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;<span class="keyword"> -- AXI4 style MAC signals</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="vhdlchar">mac_rx_valid</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="vhdlchar">mac_rx_last</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="vhdlchar">mac_rx_error</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="vhdlchar">mac_tx_data</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="vhdlchar">mac_tx_valid</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="vhdlchar">mac_tx_last</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="vhdlchar">mac_tx_error</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="vhdlchar">mac_tx_ready</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="vhdlchar">ipb_out</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">ipb_wbus</span>;<span class="keyword"> -- IPbus <span class="vhdlkeyword">bus</span> signals</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="vhdlchar">ipb_in</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">ipb_rbus</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="vhdlchar">ipb_req</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="vhdlchar">ipb_grant</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="vhdlchar">mac_addr</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">47</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">X</span><span class="vhdllogic">&quot;000000000000&quot;</span>;<span class="keyword"> -- Static MAC <span class="vhdlkeyword">and</span> IP addresses</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="vhdlchar">ip_addr</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">X</span><span class="vhdllogic">&quot;00000000&quot;</span>;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        enable: <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span> := &#39;1&#39;;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="vhdlchar">RARP_select</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span>;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="vhdlchar">pkt_rx</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="vhdlchar">pkt_tx</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="vhdlchar">pkt_rx_led</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="vhdlchar">pkt_tx_led</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="vhdlchar">oob_in</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">ipbus_trans_in_array</span><span class="vhdlchar">(</span><span class="vhdlchar">N_OOB</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">,</span> <span class="vhdlchar">X</span><span class="vhdllogic">&quot;00000000&quot;</span><span class="vhdlchar">,</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="vhdlchar">oob_out</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">ipbus_trans_out_array</span><span class="vhdlchar">(</span><span class="vhdlchar">N_OOB</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">ipbus_ctrl</span>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="code" href="classipbus__ctrl_1_1rtl.html">   66</a></span>&#160;<span class="vhdlkeyword">architecture</span> rtl <span class="vhdlkeyword">of</span> <a class="code" href="classipbus__ctrl.html">ipbus_ctrl</a> is</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">trans_in</span><span class="vhdlchar">,</span> <span class="vhdlchar">trans_in_udp</span><span class="vhdlchar">:</span> <span class="vhdlchar">ipbus_trans_in</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">trans_out</span><span class="vhdlchar">,</span> <span class="vhdlchar">trans_out_udp</span><span class="vhdlchar">:</span> <span class="vhdlchar">ipbus_trans_out</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">udp_rxpacket_ignored</span><span class="vhdlchar">,</span> <span class="vhdlchar">udp_rxpacket_dropped</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">cfg</span><span class="vhdlchar">,</span> <span class="vhdlchar">cfg_out</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">127</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">my_mac_addr</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">47</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">my_ip_addr</span><span class="vhdlchar">,</span> <span class="vhdlchar">my_ip_addr_udp</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="keyword">--  <span class="vhdlkeyword">signal</span> last_hdr: <span class="comment">std_logic_vector</span>(</span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">pkt_rx_i</span><span class="vhdlchar">,</span> <span class="vhdlchar">pkt_tx_i</span><span class="vhdlchar">,</span> <span class="vhdlchar">udp_en</span><span class="vhdlchar">,</span> <span class="vhdlchar">rarp_en</span><span class="vhdlchar">:</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">buf_in_a</span><span class="vhdlchar">:</span> <span class="vhdlchar">ipbus_trans_in_array</span><span class="vhdlchar">(</span><span class="vhdlchar">N_OOB</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">buf_out_a</span><span class="vhdlchar">:</span> <span class="vhdlchar">ipbus_trans_out_array</span><span class="vhdlchar">(</span><span class="vhdlchar">N_OOB</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;  </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    udp_if: <span class="vhdlkeyword">entity</span> work.udp_if <span class="vhdlkeyword">generic</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        BUFWIDTH  =&gt; BUFWIDTH,</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        INTERNALWIDTH  =&gt; INTERNALWIDTH ,</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        ADDRWIDTH  =&gt; ADDRWIDTH,</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        IPBUSPORT  =&gt; IPBUSPORT,</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        SECONDARYPORT  =&gt; SECONDARYPORT </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="vhdlchar">)</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        mac_clk  =&gt; mac_clk,</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        rst_macclk  =&gt; rst_macclk,</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        ipb_clk  =&gt; ipb_clk,</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        rst_ipb  =&gt; rst_ipb,</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        IP_addr  =&gt; my_ip_addr,</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        MAC_addr  =&gt; my_mac_addr,</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        enable  =&gt; udp_en,</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        RARP  =&gt; rarp_en ,</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        mac_rx_data  =&gt; mac_rx_data ,</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        mac_rx_error  =&gt; mac_rx_error ,</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        mac_rx_last  =&gt; mac_rx_last ,</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        mac_rx_valid  =&gt; mac_rx_valid ,</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        mac_tx_ready  =&gt; mac_tx_ready ,</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        pkt_done_read  =&gt; trans_out_udp.pkt_done,</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        pkt_done_write  =&gt; trans_out_udp.pkt_done,</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        raddr  =&gt; trans_out_udp.raddr,</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        waddr  =&gt; trans_out_udp.waddr,</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        wdata  =&gt; trans_out_udp.wdata,</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        we  =&gt; trans_out_udp.we,</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        busy  =&gt; trans_in_udp.busy ,</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        mac_tx_data  =&gt; mac_tx_data ,</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        mac_tx_error  =&gt; mac_tx_error ,</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        mac_tx_last  =&gt; mac_tx_last ,</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        mac_tx_valid  =&gt; mac_tx_valid ,</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        My_IP_addr  =&gt; my_ip_addr_udp,</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        pkt_rdy  =&gt; trans_in_udp.pkt_rdy,</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        rdata  =&gt; trans_in_udp.rdata,</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        rxpacket_ignored  =&gt; udp_rxpacket_ignored ,</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        rxpacket_dropped  =&gt; udp_rxpacket_dropped </div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    </div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="vhdlchar">arb_gen</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">if</span> <span class="vhdlchar">N_OOB</span> <span class="vhdlchar">&gt;</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">generate</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="vhdlchar">buf_in_a</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">oob_in</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">trans_in_udp</span>;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="vhdlchar">trans_out_udp</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">buf_out_a</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="vhdlchar">oob_out</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">buf_out_a</span><span class="vhdlchar">(</span><span class="vhdlchar">N_OOB</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        arb: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classtrans__arb.html">trans_arb</a></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            <span class="vhdlkeyword">generic</span> <span class="vhdlkeyword">map</span>(NSRC  =&gt; N_OOB + <span class="vhdllogic">1</span>   <span class="vhdlchar">)</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;                clk  =&gt; ipb_clk,</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;                rst  =&gt; rst_ipb,</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;                buf_in  =&gt; buf_in_a,</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;                buf_out  =&gt; buf_out_a,</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;                trans_out  =&gt; trans_in,</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;                trans_in  =&gt; trans_out</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">generate</span>;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="vhdlchar">n_arb_gen</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">if</span> <span class="vhdlchar">N_OOB</span> <span class="vhdlchar">=</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">generate</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="vhdlchar">trans_in</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">trans_in_udp</span>;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="vhdlchar">trans_out_udp</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">trans_out</span>;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">generate</span>;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    trans: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classtransactor.html">transactor</a> <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        clk  =&gt; ipb_clk ,</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        rst  =&gt; rst_ipb ,<span class="keyword"> -- This <span class="vhdlkeyword">is</span> probably <span class="vhdlkeyword">not</span> what we want... </span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        ipb_out  =&gt; ipb_out,</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        ipb_in  =&gt; ipb_in,</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        ipb_req  =&gt; ipb_req,</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        ipb_grant  =&gt; ipb_grant,</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        trans_in  =&gt; trans_in,</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        trans_out  =&gt; trans_out,</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        cfg_vector_in  =&gt; cfg_out,</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        cfg_vector_out  =&gt; cfg,</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        pkt_rx  =&gt; pkt_rx_i,</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        pkt_tx  =&gt; pkt_tx_i</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    </div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="vhdlchar">cfg_out</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">my_ip_addr_udp</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">X</span><span class="vhdllogic">&quot;000&quot;</span> <span class="vhdlchar">&amp;</span> <span class="vhdllogic">&quot;00&quot;</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">rarp_en</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">udp_en</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">my_mac_addr</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">X</span><span class="vhdllogic">&quot;00000000&quot;</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="keyword">--  cfg_out &lt;= my_ip_addr_udp &amp; X&quot;000&quot; &amp; &quot;</span><span class="vhdllogic">00</span>&quot; &amp; rarp_en &amp; udp_en &amp; my_mac_addr &amp; last_hdr;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="vhdlkeyword">with</span> <span class="vhdlchar">MAC_CFG</span> <span class="vhdlkeyword">select</span> <span class="vhdlchar">my_mac_addr</span> <span class="vhdlchar">&lt;=</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        <span class="vhdlchar">mac_addr</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">EXTERNAL</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="vhdlchar">cfg</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">79</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">32</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">when</span> <span class="vhdlkeyword">others</span>;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        </div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="vhdlkeyword">with</span> <span class="vhdlchar">IP_CFG</span> <span class="vhdlkeyword">select</span> <span class="vhdlchar">my_ip_addr</span> <span class="vhdlchar">&lt;=</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <span class="vhdlchar">ip_addr</span> <span class="vhdlkeyword">when</span> <span class="vhdlchar">EXTERNAL</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="vhdlchar">cfg</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">127</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">96</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">when</span> <span class="vhdlkeyword">others</span>;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        </div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="vhdlchar">udp_en</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">cfg</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">80</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">enable</span>;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="vhdlchar">rarp_en</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">cfg</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">81</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">or</span> <span class="vhdlchar">RARP_select</span>;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    stretch_rx: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classstretcher.html">stretcher</a> <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        clk  =&gt; mac_clk ,</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        d  =&gt; pkt_rx_i ,</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        q  =&gt; pkt_rx_led</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    </div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    stretch_tx: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classstretcher.html">stretcher</a> <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span>(</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        clk  =&gt; mac_clk ,</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        d  =&gt; pkt_tx_i ,</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        q  =&gt; pkt_tx_led</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    </div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="vhdlchar">pkt_rx</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">pkt_rx_i</span>;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="vhdlchar">pkt_tx</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">pkt_tx_i</span>;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="keyword">-- latch_hdr:  <span class="vhdlkeyword">process</span> (ipb_clk)</span><span class="keyword"></span></div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;<span class="keyword">--   <span class="vhdlkeyword">begin</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="keyword">--     <span class="vhdlkeyword">if</span> rising_edge(ipb_clk) <span class="vhdlkeyword">then</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="keyword">--       <span class="vhdlkeyword">if</span> rst_ipb = &#39;1&#39; <span class="vhdlkeyword">then</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="keyword">--         last_hdr &lt;= (<span class="vhdlkeyword">Others</span> =&gt; &#39;1&#39;);</span><span class="keyword"></span></div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="keyword">--       <span class="vhdlkeyword">elsif</span> trans_out_udp.pkt_done = &#39;1&#39; <span class="vhdlkeyword">then</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="keyword">--         last_hdr &lt;= &quot;</span><span class="vhdllogic">0</span>&quot; &amp; trans_in_udp.pkt_rdy &amp; trans_in_udp.busy &amp; trans_out_udp.we &amp; trans_out_udp.waddr &amp; trans_out_udp.wdata(<span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic">0</span>);<span class="keyword"></span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="keyword">--       <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</span><span class="keyword"></span></div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="keyword">--     <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</span><span class="keyword"></span></div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="keyword">--   <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span>;</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            </div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">rtl</span>;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Sep 8 2021 11:22:41 for AMC13 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
